// ===========Oooo==========================================Oooo============
// =  Copyright (C) 2014-2017 Jinan Gowin Semiconductor Technology Co.,Ltd.   
// =                     All rights reserved.                         
// =========================================================================
//           
//  __      __      __  
//  \ \    /  \    / /   [File name   ] user_if.h
//   \ \  / /\ \  / /    [Authors     ] Kai Liu
//    \ \/ /  \ \/ /     [Description ] header file for user interface
//     \  /    \  /      [Timestamp   ] Thu Aug 17 09:00:30 2017
//      \/      \/       
//                       
// ===========Oooo==========================================Oooo============

#ifndef USER_IF_H_
#define USER_IF_H_

#include "types.h"

//Host as transmitter
int type_c_cyp_if_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_power_negotiation_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_vdm_client_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_vdm_cable_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_reclaim_power_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_src_soft_reset_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_src_hard_reset_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_src_power_role_swap_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_src_data_role_swap_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_src_vconn_swap_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_src_alert_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_snk_capa_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_src_battery_capa_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_src_battery_status_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_src_manufacturer_info_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_cable_plug_manufacturer_info_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_src_country_code_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_cable_plug_country_code_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_src_country_info_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_cable_plug_country_info_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_src_security_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_cable_plug_security_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_src_fw_up_flow(uint8_t* msg_data,uint32_t data_size);
int type_c_cable_plug_fw_up_flow(uint8_t* msg_data,uint32_t data_size);

//Host as receiver
int type_c_host_respond_to_client(uint8_t* msg_data,uint32_t data_size);

//Initializes CC-Port GPIO
void cc_port_rx_GPIO_Config(void);

//Initializes ADC2
void ADC2_Config(void);

//Detects CC-Port PowerOn
void cc_port_power_on_detection(void);

#endif
