// ===========Oooo==========================================Oooo============
// =  Copyright (C) 2014-2017 Jinan Gowin Semiconductor Technology Co.,Ltd.   
// =                     All rights reserved.                         
// =========================================================================
//           
//  __      __      __  
//  \ \    /  \    / /   [File name   ] main.c
//   \ \  / /\ \  / /    [Authors     ] Kai Liu
//    \ \/ /  \ \/ /     [Description ] source file for main
//     \  /    \  /      [Timestamp   ] Thu Aug 17 09:00:30 2017
//      \/      \/       
//                       
// ===========Oooo==========================================Oooo============

#include "GOWIN_M1.h"
#include "user_if.h"

//Host
int usb_type_c_host(void)
{
	int ret = 0;

	uint8_t msg_data[MAX_DATA_SIZE] = {0};
	uint32_t data_size = 0;
	
	//Default : Cypress Interface.
	ret = type_c_cyp_if_flow(msg_data,data_size);
	if(ret)
	{
		return ret;
	}

	//Example: Power Negotiation
	//Transmit to client
	//ret = type_c_power_negotiation_flow(msg_data,data_size);
	if(ret)
	{
		return ret;
	}
	
	return ret;
}

int main(void)
{
	int ret = 0;

	/* System and Peripherals Config */
	//SystemInit();																			//Initializes system
	//NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);		//Config Interrupt Group
	cc_port_rx_GPIO_Config();													//Initializes CC RX GPIO
	//ADC2_Config();																		//Initializes ADC2
	
	/* User Application Codes */
	//cc_port_power_on_detection();											//CC Power On Detected
	ret = usb_type_c_host();													//USB Power Delivery
	if(ret)
	{
		return ret;
	}
	
	while(1);
}
