`resetall
`include "ahb_option_defs.v"
module Gowin_empu_M1 (
  /*AUTOARG*/
  // Outputs
  LOCKUP, 
  HALTED,
`ifdef GOWIN_GPIO_SUPPORT 
  GPIO,
`endif
        J3_3,   //trstn
        J3_4,   //NC
        J3_5,   //tdi
        J3_6,   //NC
        J3_7,   //tms   |       swdio
        J3_8,   //extFlash_sspi2_sio3/holdn
        J3_9,   //tck   |       swclk
        J3_10,  //extFlash_spi2_mosi/sio1
        J3_11,  //NC    |       
        J3_12,  //extFlash_spi2_sclk
        J3_13,  //tdo   |       swo
        J3_14,  //extFlash_spi2_miso/sio0
        J3_15,  //srstn
        J3_16,  //extFlash_spi2_cs
        J3_17,  //NC
        J3_18,   //extFlash_sspi2_sio2/WPn
`ifdef GOWIN_UART0_SUPPORT
  UART0RXD,
  UART0TXD,
`endif
`ifdef GOWIN_UART1_SUPPORT
  UART1RXD,
  UART1TXD,
`endif
`ifdef GOWIN_TIMER0_SUPPORT
  TIMER0EXTIN,
`endif
`ifdef GOWIN_TIMER1_SUPPORT
  TIMER1EXTIN,
`endif
  // Inputs
  EXTCLK ,
`ifdef GOWIN_RTC_SUPPORT
  RTCSRCCLK, 
`endif
  CCRX,
  CCTX,
  CCCTRL,
  CCVCONNCTRL,
  CCRD,
  CCRP,
  TEST1,
  TEST2,
  hwRstn
  ); 

//------------------------------------------------------------------------------
// Port declaration
//-------------------------------
inout   J3_3;   //trstn
inout   J3_4;   //NC
inout   J3_5;   //tdi
inout   J3_6;   //NC
inout   J3_7;   //tms
inout   J3_8;   //extFlash_sspi2_sio3/holdn
inout   J3_9;   //tck
inout   J3_10;  //extFlash_spi2_mosi/sio1
inout   J3_11;  //NC RTCK
inout   J3_12;  //extFlash_spi2_sclk
inout   J3_13;  //tdo
inout   J3_14;  //extFlash_spi2_miso/sio0
inout   J3_15;  //srstn
inout   J3_16;  //extFlash_spi2_cs
inout   J3_17;  //NC DBGQ
inout   J3_18;  //extFlash_sspi2_sio2/WPn-----------------------------------------------
 
//  output 
  // Clocks and Reset
  input                 EXTCLK;          // System clock
`ifdef GOWIN_RTC_SUPPORT
  input                 RTCSRCCLK;
`endif
  input                 hwRstn;     // System reset
  //input                 DBGRESETn;     // Power on debug reset
`ifdef GOWIN_GPIO_SUPPORT
  // GPIO 
  inout [15:0]                GPIO;
`endif
  // Misc status signals
  output                LOCKUP;        // Core is in lockup state
  output                HALTED;
`ifdef GOWIN_UART0_SUPPORT
  input                 UART0RXD;
  output                UART0TXD;
`endif
`ifdef GOWIN_UART1_SUPPORT
  input                 UART1RXD;
  output                UART1TXD;
`endif
`ifdef GOWIN_TIMER0_SUPPORT
  input                 TIMER0EXTIN;
`endif
`ifdef GOWIN_TIMER1_SUPPORT
  input                 TIMER1EXTIN;        // Core is in Halt debug state
`endif
  input            CCRX;
  output           CCTX;
  output           CCCTRL;
  output           CCVCONNCTRL;
  output           CCRD;
  output           CCRP;
  output           TEST1;
  output           TEST2;
  //SWD
  //inout                 SWDIO;
  //input                 SWDCLK;
  // JTAG and serial wire interface
  //input                 nTRST;         // JTAG reset
  //input                 SWCLKTCK;      // Serial wire and JTAG clock
  //input                 SWDITMS;       // SW Data / JTAG Test Mode Select
  //input                 TDI;           // JTAG data input
  //output                JTAGNSW;       // JTAG = 1, serial wire = 0
  //output                JTAGTOP;       // state controller indicator
  //output                TDO;           // JTAG data output
  //output                nTDOEN;        // JTAG data out enable
  //output                SWDO;          // Serial wire data out
  //output                SWDOEN;        // Serial data output enable

  
  //output                SYSRESETREQ;   // From u_cortexm1 of CortexM1Dbg.v
  
  // Debug halt/restart signals
  //input                 EDBGRQ;        // External debug request
  //input                 DBGRESTART;    // Restart from halt request
  //output                DBGRESTARTED;  // Restart from halt acknowledge

//------------------------------------------------------------------------------
// Wire declaration
//-------------------------------------------------------------------------

wire [1:0] HTRANS;
wire [2:0] HBURST;
wire [3:0] HPROT;
wire [2:0] HSIZE;
wire HWRITE;
wire HMASTLOCK;
wire [31:0] HADDR;
wire [31:0] HWDATA;
wire HRESP;
wire [31:0] HRDATA;
wire HREADY;


wire SWDIO;
wire    TDO, nTDOEN;
wire    nTRST, SWCLKTCK, SWDITMS, TDI;
wire SYSRESETREQ;
wire    SWDO, SWDOEN;
wire wdog_reset_req;
wire [31:0] IRQ;
wire NMI;
reg     [3:0]   sysRstGen = 4'b0;
reg             dbgRstGen = 1'b0;

wire    SYSRESETn       =   sysRstGen[3];
wire    DBGRESETn       =   dbgRstGen;

assign  nTRST           = J3_3;
assign  SWCLKTCK        = J3_9;
//assign  SWDITMS               = J3_7;
assign  TDI                     = J3_5;

assign  J3_13 = TDO;
assign  J3_15 = SYSRESETn;
assign  J3_11 = 0;
assign  J3_17 = 0;

assign  J3_4  = 0;
assign  J3_6  = 0;
assign  J3_8  = 0;
assign  J3_10  = 0;
assign  J3_12  = 0;
assign  J3_14  = 0;
assign  J3_16  = 0;
assign  J3_18  = 0;

always@(posedge HCLK)begin
    if(!hwRstn | !DBGRESETn | SYSRESETREQ |wdog_reset_req)
        sysRstGen <= 4'b0;
    else
        sysRstGen <= {sysRstGen[2:0],1'b1};
end
always@(posedge HCLK)begin
    if(!hwRstn)
        dbgRstGen <= 1'b0;
    else
        dbgRstGen <= 1'b1;
end

IOBUF swdio (
    .O(SWDITMS),
    .IO(J3_7),
    .I(SWDO), 
    .OEN(!(SWDOEN  & !JTAGNSW)));


assign  J3_4  = 0;
assign  J3_6  = 0;
assign  J3_8  = 0;
assign  J3_10  = 0;
assign  J3_12  = 0;
assign  J3_14  = 0;
assign  J3_16  = 0;
assign  J3_18  = 0;

GW_PLL sysclk(
    .clkin(EXTCLK),
    .clkout(HCLK));

CortexM1DbgIntegrationWrapper M1_inst(
    .DBGRESTARTED(),
    .JTAGNSW(JTAGNSW),
    .JTAGTOP(), 
    .TDO(TDO), 
    .nTDOEN(nTDOEN), 
    .SWDO(SWDO), 
    .SWDOEN(SWDOEN), 
    .LOCKUP(LOCKUP), 
    .HALTED(HALTED),
    .SYSRESETREQ(SYSRESETREQ),
    .HTRANS(HTRANS), 
    .HBURST(HBURST), 
    .HPROT(HPROT), 
    .HSIZE(HSIZE), 
    .HWRITE(HWRITE), 
    .HMASTLOCK(HMASTLOCK), 
    .HADDR(HADDR), 
    .HWDATA(HWDATA), 
  // Inputs
    .HCLK(HCLK), 
    .SYSRESETn(SYSRESETn), 
    .IRQ(IRQ), 
    .NMI(NMI),
    .DBGRESETn(DBGRESETn),
    .EDBGRQ(1'b0),
    .DBGRESTART(1'b0),
    .nTRST(nTRST), 
    .SWCLKTCK(SWCLKTCK), 
    .SWDITMS(SWDITMS), 
    .TDI(TDI), 
    .HREADY(HREADY), 
    .HRESP(HRESP), 
    .HRDATA(HRDATA)
);

GowinCM1AhbExtWrapper u_GowinCM1AhbExtWrapper(

    .IRQ(IRQ),         // External interrupts
    .NMI(NMI),         // Non-maskable interrupt
`ifdef GOWIN_RTC_SUPPORT
    .RTCSRCCLK(RTCSRCCLK),
`endif
    .HCLK(HCLK),
    .HTRANS(HTRANS),
    .HBURST(HBURST),
    .HPROT(HPROT),
    .HSIZE(HSIZE),
    .HWRITE(HWRITE),
    .HMASTLOCK(HMASTLOCK),
    .HADDR(HADDR),
    .HWDATA(HWDATA),
    .HRESP(HRESP),
    .HRDATA(HRDATA),
    .HREADY(HREADY),
`ifdef GOWIN_TIMER0_SUPPORT
    .TIMER0EXTIN          (TIMER0EXTIN),
`endif 
`ifdef GOWIN_TIMER1_SUPPORT
    .TIMER1EXTIN          (TIMER1EXTIN),
`endif
`ifdef GOWIN_UART0_SUPPORT
    .UART0RXD             (UART0RXD),
    .UART0TXD             (UART0TXD),
`endif
`ifdef GOWIN_UART1_SUPPORT
    .UART1RXD             (UART1RXD),
    .UART1TXD             (UART1TXD),
`endif
`ifdef GOWIN_WDOG_SUPPORT
    .WDOGRESREQ           (wdog_reset_req),
`endif
`ifdef GOWIN_GPIO_SUPPORT
    //GPIO
    .GPIO(GPIO),
`endif
    .CCEXTCLOCK(EXTCLK),
    .CCRX(CCRX),
    .CCTX(CCTX),
    .CCCTRL(CCCTRL),
    .CCVCONNCTRL(CCVCONNCTRL),
    .CCRD(CCRD),
    .CCRP(CCRP),
    .TEST1(TEST1),
    .TEST2(TEST2),
    .SYSRESETn(SYSRESETn),
    .PORESETn(PORESETn) 
    );   
endmodule       


